# Generated by Django 3.2.13 on 2023-07-24 07:09

import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion
import simple_history.models


class Migration(migrations.Migration):

    dependencies = [
        ('APIs', '0002_auto_20230711_1940'),
    ]

    operations = [
        migrations.CreateModel(
            name='Internship',
            fields=[
                ('id', models.CharField(max_length=15, primary_key=True, serialize=False)),
                ('company_name', models.CharField(max_length=50)),
                ('address', models.CharField(max_length=1000)),
                ('company_type', models.CharField(max_length=50)),
                ('nature_of_business', models.CharField(default='', max_length=50)),
                ('type_of_organisation', models.CharField(default='', max_length=50)),
                ('website', models.CharField(blank=True, max_length=100)),
                ('company_details', models.CharField(blank=True, default=None, max_length=1000, null=True)),
                ('company_details_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_company_details_pdf', models.BooleanField(default=False)),
                ('city', models.CharField(default='', max_length=50)),
                ('state', models.CharField(default='', max_length=50)),
                ('country', models.CharField(default='', max_length=50)),
                ('pin_code', models.IntegerField(default=None, null=True)),
                ('selection_procedure_rounds', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=10)),
                ('selection_procedure_details', models.CharField(blank=True, max_length=1000)),
                ('selection_procedure_details_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_selection_procedure_details_pdf', models.BooleanField(default=False)),
                ('description_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_description_pdf', models.BooleanField(default=False)),
                ('description', models.CharField(default=None, max_length=1000, null=True)),
                ('interning_period_from', models.DateField(default=None, null=True)),
                ('interning_period_to', models.DateField(default=None, null=True)),
                ('season', models.CharField(choices=[['summer', 'Summer'], ['winter', 'Winter'], ['autumn', 'Autumn'], ['spring', 'Spring']], default=None, max_length=10)),
                ('is_work_from_home', models.BooleanField(default=False)),
                ('sophomore_eligible', models.BooleanField(default=False)),
                ('tentative_no_of_offers', models.IntegerField(default=None, null=True)),
                ('stipend_description_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_stipend_description_pdf', models.BooleanField(default=False)),
                ('stipend', models.IntegerField(default=None, null=True)),
                ('facilities_provided', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(choices=[['Accommodation', 'Accommodation'], ['Food', 'Food'], ['Transport', 'Transport'], ['Medical', 'Medical']], max_length=20), default=list, size=4)),
                ('additional_facilities', models.CharField(blank=True, default=None, max_length=1000, null=True)),
                ('academic_requirements', models.CharField(blank=True, default=None, max_length=1000, null=True)),
                ('contact_person_name', models.CharField(max_length=100)),
                ('phone_number', models.PositiveBigIntegerField()),
                ('email', models.EmailField(max_length=254)),
                ('contact_person_designation', models.CharField(default='', max_length=50)),
                ('telephone_number', models.PositiveBigIntegerField(blank=True, default=None, null=True)),
                ('email_verified', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(default=None, null=True)),
                ('updated_at', models.DateTimeField(default=None, null=True)),
                ('changed_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='APIs.user')),
            ],
        ),
        migrations.CreateModel(
            name='HistoricalInternship',
            fields=[
                ('id', models.CharField(db_index=True, max_length=15)),
                ('company_name', models.CharField(max_length=50)),
                ('address', models.CharField(max_length=1000)),
                ('company_type', models.CharField(max_length=50)),
                ('nature_of_business', models.CharField(default='', max_length=50)),
                ('type_of_organisation', models.CharField(default='', max_length=50)),
                ('website', models.CharField(blank=True, max_length=100)),
                ('company_details', models.CharField(blank=True, default=None, max_length=1000, null=True)),
                ('company_details_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_company_details_pdf', models.BooleanField(default=False)),
                ('city', models.CharField(default='', max_length=50)),
                ('state', models.CharField(default='', max_length=50)),
                ('country', models.CharField(default='', max_length=50)),
                ('pin_code', models.IntegerField(default=None, null=True)),
                ('selection_procedure_rounds', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=10)),
                ('selection_procedure_details', models.CharField(blank=True, max_length=1000)),
                ('selection_procedure_details_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_selection_procedure_details_pdf', models.BooleanField(default=False)),
                ('description_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_description_pdf', models.BooleanField(default=False)),
                ('description', models.CharField(default=None, max_length=1000, null=True)),
                ('interning_period_from', models.DateField(default=None, null=True)),
                ('interning_period_to', models.DateField(default=None, null=True)),
                ('season', models.CharField(choices=[['summer', 'Summer'], ['winter', 'Winter'], ['autumn', 'Autumn'], ['spring', 'Spring']], default=None, max_length=10)),
                ('is_work_from_home', models.BooleanField(default=False)),
                ('sophomore_eligible', models.BooleanField(default=False)),
                ('tentative_no_of_offers', models.IntegerField(default=None, null=True)),
                ('stipend_description_pdf_names', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(default=None, max_length=100, null=True), blank=True, default=list, size=5)),
                ('is_stipend_description_pdf', models.BooleanField(default=False)),
                ('stipend', models.IntegerField(default=None, null=True)),
                ('facilities_provided', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(choices=[['Accommodation', 'Accommodation'], ['Food', 'Food'], ['Transport', 'Transport'], ['Medical', 'Medical']], max_length=20), default=list, size=4)),
                ('additional_facilities', models.CharField(blank=True, default=None, max_length=1000, null=True)),
                ('academic_requirements', models.CharField(blank=True, default=None, max_length=1000, null=True)),
                ('contact_person_name', models.CharField(max_length=100)),
                ('phone_number', models.PositiveBigIntegerField()),
                ('email', models.EmailField(max_length=254)),
                ('contact_person_designation', models.CharField(default='', max_length=50)),
                ('telephone_number', models.PositiveBigIntegerField(blank=True, default=None, null=True)),
                ('email_verified', models.BooleanField(default=False)),
                ('created_at', models.DateTimeField(default=None, null=True)),
                ('updated_at', models.DateTimeField(default=None, null=True)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField(db_index=True)),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('changed_by', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='APIs.user')),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='APIs.user')),
            ],
            options={
                'verbose_name': 'historical internship',
                'verbose_name_plural': 'historical internships',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': ('history_date', 'history_id'),
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
    ]
